## mingw-w64-lexbor-2.6.0-1.src.tar.zst

=== packaging/rpm/Makefile ===
#!/usr/bin/make

default:
	@echo "available targets: rpm"

all: build

build:
	./build.sh --version=$(VERSION) --arch=$(ARCH) --yes

clean:
	rm -rf build

.PHONY: default all build clean

=== examples/lexbor/punycode/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12...3.27)

################
## Sources
#########################
file(GLOB_RECURSE EXAMPLES_LEXBOR_PUNYCODE_SOURCES "*.c")

################
## Create executable
#########################
EXECUTABLE_LIST("" "${EXAMPLES_LEXBOR_PUNYCODE_SOURCES}" ${EXAMPLES_DEPS_LIB_NAMES})

=== test/lexbor/dom/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12...3.27)

################
## Search and Includes
#########################
include_directories(".")

################
## Sources
#########################
file(GLOB_RECURSE TEST_LEXBOR_DOM_SOURCES "*.c")

################
## Create tests
#########################
EXECUTABLE_LIST("lexbor_dom_" "${TEST_LEXBOR_DOM_SOURCES}" ${TEST_DEPS_LIB_NAMES})
APPEND_TESTS("lexbor_dom_" "${TEST_LEXBOR_DOM_SOURCES}")

=== test/lexbor/encoding/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12...3.27)

################
## Search and Includes
#########################
include_directories(".")

################
## Sources
#########################
file(GLOB TEST_LEXBOR_ENCODING_FUZZ_SOURCES "fuzz_*.c")
file(GLOB_RECURSE TEST_LEXBOR_ENCODING_BUFFER_SOURCES "buffer/*.c")
file(GLOB_RECURSE TEST_LEXBOR_ENCODING_SINGLE_SOURCES "single/*.c")

################
## ARGS for tests
#########################
set(buffer_big5_arg "${CMAKE_SOURCE_DIR}/test/files/lexbor/encoding/big5_map_decode.txt")
set(buffer_euc_jp_arg "${CMAKE_SOURCE_DIR}/test/files/lexbor/encoding/euc_jp_map_decode.txt")
set(buffer_euc_kr_arg "${CMAKE_SOURCE_DIR}/test/files/lexbor/encoding/euc_kr_map_decode.txt")
set(buffer_iso_2022_jp_arg "${CMAKE_SOURCE_DIR}/test/files/lexbor/encoding/iso_2022_jp_map_decode.txt")
set(buffer_shift_jis_arg "${CMAKE_SOURCE_DIR}/test/files/lexbor/encoding/shift_jis_map_decode.txt")
set(buffer_gb18030_arg "${CMAKE_SOURCE_DIR}/test/files/lexbor/encoding/gb18030_map_decode.txt")

set(single_big5_arg "${CMAKE_SOURCE_DIR}/test/files/lexbor/encoding/big5_map_decode.txt")
set(single_euc_jp_arg "${CMAKE_SOURCE_DIR}/test/files/lexbor/encoding/euc_jp_map_decode.txt")
set(single_euc_kr_arg "${CMAKE_SOURCE_DIR}/test/files/lexbor/encoding/euc_kr_map_decode.txt")
set(single_iso_2022_jp_arg "${CMAKE_SOURCE_DIR}/test/files/lexbor/encoding/iso_2022_jp_map_decode.txt")
set(single_shift_jis_arg "${CMAKE_SOURCE_DIR}/test/files/lexbor/encoding/shift_jis_map_decode.txt")
set(single_gb18030_arg "${CMAKE_SOURCE_DIR}/test/files/lexbor/encoding/gb18030_map_decode.txt")

################
## Create tests
#########################
EXECUTABLE_LIST("lexbor_encoding_" "${TEST_LEXBOR_ENCODING_FUZZ_SOURCES}" ${TEST_DEPS_LIB_NAMES})
APPEND_TESTS("lexbor_encoding_" "${TEST_LEXBOR_ENCODING_FUZZ_SOURCES}")

EXECUTABLE_LIST("lexbor_encoding_" "${TEST_LEXBOR_ENCODING_BUFFER_SOURCES}" ${TEST_DEPS_LIB_NAMES})
APPEND_TESTS("lexbor_encoding_" "${TEST_LEXBOR_ENCODING_BUFFER_SOURCES}")

EXECUTABLE_LIST("lexbor_encoding_" "${TEST_LEXBOR_ENCODING_SINGLE_SOURCES}" ${TEST_DEPS_LIB_NAMES})
APPEND_TESTS("lexbor_encoding_" "${TEST_LEXBOR_ENCODING_SINGLE_SOURCES}")

=== test/lexbor/html/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12...3.27)

################
## Search and Includes
#########################
include_directories(".")

################
## Sources
#########################
file(GLOB_RECURSE TEST_LEXBOR_HTML_SOURCES "*.c")

if(LEXBOR_BUILD_TESTS_CPP)
    file(GLOB_RECURSE TEST_LEXBOR_HTML_SOURCES_CPP "*.cpp")
endif()

################
## ARGS for tests
#########################
set(tokenizer_tokens_arg "${CMAKE_SOURCE_DIR}/test/files/lexbor/html/tokenizer")
set(tree_builder_arg "${CMAKE_SOURCE_DIR}/test/files/lexbor/html/html5_test")

################
## Create tests
#########################
EXECUTABLE_LIST("lexbor_html_" "${TEST_LEXBOR_HTML_SOURCES}" ${TEST_DEPS_LIB_NAMES})
APPEND_TESTS("lexbor_html_" "${TEST_LEXBOR_HTML_SOURCES}")

if(LEXBOR_BUILD_TESTS_CPP)
    EXECUTABLE_LIST("lexbor_html_" "${TEST_LEXBOR_HTML_SOURCES_CPP}" ${TEST_DEPS_LIB_NAMES})
    APPEND_TESTS("lexbor_html_" "${TEST_LEXBOR_HTML_SOURCES_CPP}")
endif()

=== test/lexbor/selectors/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12...3.27)

################
## Search and Includes
#########################
include_directories(".")

################
## Sources
#########################
file(GLOB_RECURSE TEST_LEXBOR_SELECTORS_SOURCES "*.c")

################
## Create tests
#########################
EXECUTABLE_LIST("lexbor_selectors_" "${TEST_LEXBOR_SELECTORS_SOURCES}" ${TEST_DEPS_LIB_NAMES})
APPEND_TESTS("lexbor_selectors_" "${TEST_LEXBOR_SELECTORS_SOURCES}")

=== PKGBUILD ===
# Maintainer: Vincent Torri <vincent.torri@gmail.com>

_realname=lexbor
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=2.6.0
pkgrel=1
pkgdesc="Fast C99 HTML renderer library (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://lexbor.com/'
msys2_repository_url='https://github.com/lexbor/lexbor/'
msys2_changelog_url='https://github.com/lexbor/lexbor/blob/master/CHANGELOG.md'
license=('spdx:Apache-2.0')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
source=("https://github.com/lexbor/lexbor/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz")
sha256sums=('e9bb1aa8027ab92f11d5e8e6e7dc9b7bd632248c11a288eec95ade97bb7951a3')

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DLEXBOR_BUILD_TESTS=ON \
      -DLEXBOR_BUILD_TESTS_CPP=ON \
      "${extra_config[@]}" \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  # Workaround: try to build twice to fix dll copy issue
  cmake --build "build-${MSYSTEM}" || cmake --build "build-${MSYSTEM}"
}

check() {
  cmake --build "build-${MSYSTEM}" --target test
}

package() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}"

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
